config/routes.rb
Rails.application.routes.draw do
  get 'domain_names/index'
  get 'home/index'
  root 'home#index'
  # devise_for :users
  devise_for :users, :controllers => {:registrations => "devise/registrations"}
  resources :requests
  get '/connections/my_connections', to: 'connections#my_connections'
  get '/jobs/my_posted_jobs', to: 'jobs#my_posted_jobs'
  get '/jobs/my_applied_jobs', to: 'jobs#my_applied_jobs'
  get '/jobs/saved_jobs', to: 'jobs#saved_jobs'
  get '/jobs/states', to: 'jobs#states'
  get '/jobs/cities', to: 'jobs#cities'
  resources :connections
  resources :posts do
    resources :comments
    resources :likes
  end
  resources :comments do
    resources :likes
  end
  resources :user_groups, only: [:create, :destroy, :update]
  resources :user_jobs, only: [:create, :destroy, :update]
  resources :user_saved_jobs, only: [:create, :destroy, :update]
  resources :jobs
  resources :resumes
  resources :likes
  resources :groups
  resources :specialities, only: [:index]
  resources :domain_names, only: [:index]
  resources :poll_responses, only: [:create, :destroy]
  resources :registration_steps
  resources :events
  resources :businesses
  resources :courses
  resources :categories
  get '/get_users' => 'events#get_users'

  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

app/models/group.rb
class Group < ApplicationRecord
    validates :name, :description, presence: :true

    has_many :user_groups
    has_many :users, through: :user_groups
    belongs_to :creator, class_name: 'User', foreign_key: :user_id

    # scope :accepted, -> { joins(:user_groups).where('user_group.status=?', 1) }
end


# t.string "name"
# t.string "description"
# t.integer "user_id"
# t.boolean "visible"
# t.boolean "can_invite_connections"

app/controllers/groups_controller.rb
class GroupsController < ApplicationController
	def new
		@group = Group.new()
	end

	def create
		@group = Group.new(group_params)
		@group.user_id = current_user.id
		UserGroup.create(user_id: current_user.id, group_id: @group.id, status: 1)	if @group.save
		# if @group.save
		# 	redirect_to groups_path
		# else
		# 	render :new
		# end
		respond_to do |format|
			format.js
		end
	end

	def index
		@group = Group.new()
		@groups = current_user.user_groups.where('user_groups.status = ?', 1)
		@requested_groups = current_user.user_groups.where('status = ?', 0)
		@requests_groups = UserGroup.where('group_id IN (?) and status = ?', current_user.owned_groups.pluck(:id), 0).includes(:group)
		@owned_groups = current_user.owned_groups.pluck(:id)
	end

	def show
		@group = Group.find(params[:id])
		@users = User.all
	end

	def destroy
		@group.destroy
		respond_to do |format|
			format.js
		end
	end
	

	private

	def group_params
		params.require(:group).permit!
	end
end

app/helpers/groups_helper.rb
module GroupsHelper
end

app/views/groups/_action_buttons.html.erb
<% if %w[your_groups].include?(tab) %>
	<%= link_to '#', :class => 'button white' do %>
		<span class="badge rounded-pill bg-secondary">Copy link to group</span>
	<% end %>
	<%= link_to '#', :class => 'button white' do %>
		<span class="badge rounded-pill bg-info">Update your settings</span>
	<% end %>
	<% if @owned_groups.exclude?(group.id) %>
		<%= link_to user_group_path(user_group), method: :delete, remote: true, :class => 'button white' do %>
			<span class="badge rounded-pill bg-danger">Leave this group</span>
		<% end %>
	<% else %>
		<%= link_to group_path(group), method: :delete, remote: true, :class => 'button white' do %>
			<span class="badge rounded-pill bg-danger">Delete this group</span>
		<% end %>
	<% end %>
<% elsif %w[requested].include?(tab) %>
	<%= link_to '#', :class => 'button white' do %>
		<span class="badge rounded-pill bg-secondary">Withdraw</span>
	<% end %>
<% else %w[requests].include?(tab) %>
	<div id="take_action_<%= user_group.id %>">
		<%= link_to user_group_path(user_group, user_group: {status: 1}), method: 'put', remote: :true, :class => 'button white' do %>
			<span class="badge rounded-pill bg-secondary">Accept</span>
		<% end %>
		<%= link_to user_group_path(user_group), method: 'delete', remote: :true, :class => 'button white' do %>
			<span class="badge rounded-pill bg-danger">Decline</span>
		<% end %>
	</div>	
<% end %>

app/views/groups/_card.html.erb
<div class='list-group-item list-group-item-action d-flex justify-content-between align-items-center'>
	<div class="flex-column">
		<%=link_to group.name, group_path(group) %>  
		<% if @owned_groups.include?(group.id) %>
			<h6><span class="badge bg-secondary">Owner</span></h6>
		<% end %>	
		<p><small>by Miguel de Cervantes</small></p>
		<%= render :partial => 'action_buttons', locals: { tab: tab, user_group: user_group, group: group } %>
	</div>
	<div class="image-parent">
		<img src="https://s3.eu-central-1.amazonaws.com/bootstrapbaymisc/blog/24_days_bootstrap/don_quixote.jpg" class="img-fluid" alt="quixote">
	</div>
</div>

app/views/groups/_form.html.erb
<%= form_for @group, remote: :true do |f| %>
  <% if @group.errors.any? %>
    <ul class='errors'>
      <% @group.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
    </ul>
  <% end %>
  <div class="form-group">
    <div class="form-group col-md-12">
      <%= f.label :name %><br />
    	<%= f.text_field :name, class: 'form-control', placeholder: 'Group Name' %>
    </div>
    <div class="form-group col-md-12 mt-4">
      <%= f.label :description %><br />
    	<%= f.text_area :description, class: 'form-control', placeholder: 'What is the purpose of your group?' %>
    </div>
    <div class="form-group col-md-12 mt-4">
      <%= f.label :group_descoverability %><br />
    	<div class="form-check mt-2">
        <%= f.radio_button :visible, true, class: 'form-check-input', id: 'exampleRadios1', :checked => true %> 
			  <label class="form-check-label" for="exampleRadios1">
			    Listed (Group appears in search results and is visible to others on members’ profiles.)
			  </label>
			</div>
			<div class="form-check">
        <%= f.radio_button :visible, false, class: 'form-check-input', id: 'exampleRadios2' %> 
			  <label class="form-check-label" for="exampleRadios2">
			    Unlisted (Group does not appear in search results for non-group members and is not visible to others on members’ profiles.)
			  </label>
			</div>
    </div>
    <div class="form-group col-md-12 mt-4">
      <%= f.label :permissions %><br />
    	<div class="form-check mt-2">
        <%= f.radio_button :can_invite_connections, true, class: 'form-check-input', id: 'exampleRadios3', :checked => true %> 
			  <label class="form-check-label" for="exampleRadios3">
			    Allow members to invite their connections (If disabled, only admins will be able to invite 1st degree connections to the group. All requests to join will still require admin approval.
)
			  </label>
			</div>
			<div class="form-check">
        <%= f.radio_button :can_invite_connections, false, class: 'form-check-input', id: 'exampleRadios4' %> 
			  <label class="form-check-label" for="exampleRadios4">
			    Require new posts to be reviewed by admins (If disabled, any remaining pending posts will still require approval.)
			  </label>
			</div>
    </div>
  </div>
<% end %>



<!-- t.string "name"
    t.string "description"
    t.integer "user_id"
    t.boolean "visible"
    t.boolean "can_invite_connections"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["user_id"], name: "index_groups_on_user_id" -->

app/views/groups/create.js.erb
<% if @group.errors.blank? %>
	$('#newGroup').html('').html("<%= escape_javascript render(:partial => 'groups/form', :locals => { :@group => Group.new }) %>");
	$('#newGroupModal').modal('hide')
	toastr.success('You have successfully created your new group')
<% else %>
	$('#newGroup').html('').html("<%= escape_javascript render(:partial => 'groups/form') %>");
<% end %>

app/views/groups/index.html.erb
<div class="panel panel-default">
  <div class="panel-heading float-right">
    <%#= link_to 'Create group', new_group_path(), class: 'btn btn-primary btn-sm' %>
		<button type="button" class="btn btn-primary btn-sm" data-bs-toggle="modal" data-bs-target="#newGroupModal">
			Create group
		</button>
  </div>
  <div class="panel-body">
    <ul class="nav nav-pills mb-3" id="pills-tab" role="tablist">
      <li class="nav-item" role="presentation">
        <button class="nav-link active" id="pills-home-tab" data-bs-toggle="pill" data-bs-target="#pills-home" type="button" role="tab" aria-controls="pills-home" aria-selected="true">Your groups</button>
      </li>
      <li class="nav-item" role="presentation">
        <button class="nav-link" id="pills-profile-tab" data-bs-toggle="pill" data-bs-target="#pills-profile" type="button" role="tab" aria-controls="pills-profile" aria-selected="false">Requested</button>
      </li>
      <li class="nav-item" role="presentation">
        <button class="nav-link" id="pills-contact-tab" data-bs-toggle="pill" data-bs-target="#pills-contact" type="button" role="tab" aria-controls="pills-contact" aria-selected="false">Requests</button>
      </li>
    </ul>
    <div class="tab-content" id="pills-tabContent">
      <div class="tab-pane fade show active" id="pills-home" role="tabpanel" aria-labelledby="pills-home-tab" tabindex="0">
        <div class="row">
          <div class="col-12 col-sm-12 col-lg-12">
            <ul class="list-group">
              <% @groups.each do |user_group| %>
                <% group = user_group.group %>
                <%= render :partial => 'card', locals: {group: group, tab: 'your_groups', user_group: user_group}  %>
              <% end %>
            </ul>
          </div>
        </div>
      </div>
      <div class="tab-pane fade" id="pills-profile" role="tabpanel" aria-labelledby="pills-profile-tab" tabindex="0">
        <div class="tab-pane fade show active" id="pills-home" role="tabpanel" aria-labelledby="pills-home-tab" tabindex="0">
          <div class="row">
            <div class="col-12 col-sm-12 col-lg-12">
              <ul class="list-group">
                <% @requested_groups.each do |user_group| %>
                  <%group = user_group.group %>
                  <%= render :partial => 'card', locals: {group: group, user_group: user_group, tab: 'requested'}  %>
                <% end %>
              </ul>
            </div>
          </div>
        </div>
      </div>
      <div class="tab-pane fade" id="pills-contact" role="tabpanel" aria-labelledby="pills-contact-tab" tabindex="0">
        <div class="tab-pane fade show active" id="pills-home" role="tabpanel" aria-labelledby="pills-home-tab" tabindex="0">
          <div class="row">
            <div class="col-12 col-sm-12 col-lg-12">
              <ul class="list-group">
                <% @requests_groups.each do |user_group| %>
                  <% group = user_group.group %>
                  <%= render :partial => 'card', locals: {group: group, user_group: user_group,tab: 'requests'}  %>
                <% end %>
              </ul>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>


<!-- Modal -->
<div class="modal fade" id="newGroupModal" tabindex="-1" aria-labelledby="newGroupModalLabel" aria-hidden="true">
  <div class="modal-dialog modal-lg">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="newGroupModalLabel">Create group</h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
      </div>
      <div class="modal-body" id='newGroup'>
        <%= render 'groups/form' %>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
        <button type="submit" form="new_group" class="btn btn-primary">Create</button>
      </div>
    </div>
  </div>
</div>

app/views/groups/new.html.erb
<%= render 'form' %>

app/views/groups/show.html.erb
<div class='row'>
	<div class='col-md-3'>
	</div>
	<div class='col-md-6'>
	</div>
	<div class='col-md-3'>
		<button type="button" class="btn btn-info" data-bs-toggle="modal" data-bs-target="#inviteConnections">
			Invite Connections
		</button>
	</div>
</div>

<!-- Modal -->
<div class="modal fade" id="inviteConnections" tabindex="-1" aria-labelledby="inviteConnectionsLabel" aria-hidden="true">
  <div class="modal-dialog modal-lg">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="inviteConnectionsLabel">Invite connections</h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
      </div>
      <div class="modal-body" id='newJob'>
        <div class='row'>
					<div class='col-md-12'>
						<%= form_tag("/search", :method => "get") do %>
							<%= text_field_tag :login_aei, "", class: 'form-control', placeholder: 'Search by name' %>
						<% end %>
					</div>
				</div>
				<div class='row mt-4'>
					<div class='col-md-8'>
						<div class='row'>
							<div class='col-md-12' style='border: 1px solid grey'>
								Filter options will go here
							</div>
						</div>
						<div class='row'>
							<div class='col-md-12'>
								<% @users.all.each do |user| %>
									<div class='row mt-2'>
										<div class='col-md-12'>
											<%= check_box_tag 'users[user-ids][]', user.id, nil, :id => "user-#{user.id}" %>
											<label for="user-<%= user.id %>"><%= user.name %></label>
										</div>
									</div>
								<% end %>
							</div>
						</div>
					</div>
					<div class='col-md-4'>
						<div class='row'>
							<div class='col-md-6'>
								<span id='selected-count'> 0 selected </span>
							</div>
							<div class='col-md-6'>
								<%= link_to 'Unselect all', 'javascript:void(0)', id: 'unselect-all' %>
							</div>
						</div>
						<div class='row mt-2'>
							<ul id='users-list'>
							</ul>
						</div>
					</div>
				</div>
      </div>
      <%# <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
        <button type="submit" form="new_job" class="btn btn-primary">Post Job</button>
      </div> %>
    </div>
  </div>
</div>

<script type="text/javascript">
  $("input[name='users[user-ids][]']").change(function(){
		$("#users-list").append('<li> '+ $(this).next('label').text() +' <a href="javascript:void(0)" class="remove-user" id='+ $(this).attr('id') +'> <i class="fa fa-close"></i></a> </li>');

		selected_count()
  })

	function selected_count(){
		len = $("input[name='users[user-ids][]']:checked").length
		$('#selected-count').text( len + ' selected')
	}

	$(document).on('click', '.remove-user', function(){
		thisRef = $(this).closest('li')
		thisRef.remove()
		var id = $(this).attr('id')
		var checkid = $('#' + id);
 		checkid.prop("checked", false);
		selected_count()
	})

	$('#unselect-all').on('click', function(){
		$('.remove-user').trigger('click')
	})
</script>	